"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasWrapper = hasWrapper;
exports.setFlags = setFlags;
exports.examples = exports.run = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));

  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };

  return data;
}

/* eslint object-shorthand: 0 */
var CONFIG_KEYS = [// 'reporter',
'registryFolders', 'linkedModules', // 'registries',
'cache', 'cwd', 'looseSemver', 'commandName', 'preferOffline', 'modulesFolder', 'globalFolder', 'linkFolder', 'offline', 'binLinks', 'ignorePlatform', 'ignoreScripts', 'disablePrepublish', 'nonInteractive', 'workspaceRootFolder', 'lockfileFolder', 'networkConcurrency', 'childConcurrency', 'networkTimeout', 'workspacesEnabled', 'workspacesNohoistEnabled', 'pruneOfflineMirror', 'enableMetaFolder', 'enableLockfileVersions', 'linkFileDependencies', 'cacheFolder', 'tempFolder', 'production'];

function hasWrapper(flags, args) {
  return args[0] !== 'get';
}

function setFlags(commander) {
  commander.description('Manages the yarn configuration files.');
}

var _buildSubCommands = (0, _buildSubCommands2()["default"])('config', {
  set: function set(config, reporter, flags, args) {
    return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee() {
      var _args, key, _args$, val, yarnConfig;

      return _regenerator()["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(args.length === 0 || args.length > 2)) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return", false);

            case 2:
              _args = (0, _slicedToArray2()["default"])(args, 2), key = _args[0], _args$ = _args[1], val = _args$ === void 0 ? true : _args$;
              yarnConfig = config.registries.yarn;
              _context.next = 6;
              return yarnConfig.saveHomeConfig((0, _defineProperty2()["default"])({}, key, val));

            case 6:
              reporter.success(reporter.lang('configSet', key, val));
              return _context.abrupt("return", true);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  },
  get: function get(config, reporter, flags, args) {
    if (args.length !== 1) {
      return false;
    }

    reporter.log(String(config.getOption(args[0])), {
      force: true
    });
    return true;
  },
  "delete": function () {
    var _delete2 = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(config, reporter, flags, args) {
      var key, yarnConfig;
      return _regenerator()["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(args.length !== 1)) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt("return", false);

            case 2:
              key = args[0];
              yarnConfig = config.registries.yarn;
              _context2.next = 6;
              return yarnConfig.saveHomeConfig((0, _defineProperty2()["default"])({}, key, undefined));

            case 6:
              reporter.success(reporter.lang('configDelete', key));
              return _context2.abrupt("return", true);

            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    function _delete(_x, _x2, _x3, _x4) {
      return _delete2.apply(this, arguments);
    }

    return _delete;
  }(),
  list: function list(config, reporter, flags, args) {
    if (args.length) {
      return false;
    }

    reporter.info(reporter.lang('configYarn'));
    reporter.inspect(config.registries.yarn.config);
    reporter.info(reporter.lang('configNpm'));
    reporter.inspect(config.registries.npm.config);
    return true;
  },
  current: function current(config, reporter, flags, args) {
    if (args.length) {
      return false;
    }

    reporter.log(JSON.stringify(config, CONFIG_KEYS, 2), {
      force: true
    });
    return true;
  }
}),
    run = _buildSubCommands.run,
    examples = _buildSubCommands.examples;

exports.examples = examples;
exports.run = run;
//# sourceMappingURL=config.js.map
