"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasWrapper = hasWrapper;
exports.run = run;
exports.setFlags = setFlags;
exports.examples = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _errors() {
  var data = require("../../errors.js");

  _errors = function _errors() {
    return data;
  };

  return data;
}

function _lockfile() {
  var data = require("../../lockfile");

  _lockfile = function _lockfile() {
    return data;
  };

  return data;
}

function hasWrapper(commander, args) {
  return false;
}

function run(_x, _x2, _x3, _x4) {
  return _run.apply(this, arguments);
}

function _run() {
  _run = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(config, reporter, flags, args) {
    var manifest, entry, pattern;
    return _regenerator()["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!flags.useManifest) {
              _context.next = 6;
              break;
            }

            _context.next = 3;
            return config.readJson(flags.useManifest);

          case 3:
            manifest = _context.sent;
            _context.next = 9;
            break;

          case 6:
            _context.next = 8;
            return config.readRootManifest();

          case 8:
            manifest = _context.sent;

          case 9:
            if (manifest.name) {
              _context.next = 11;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('noName'));

          case 11:
            if (manifest.version) {
              _context.next = 13;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('noVersion'));

          case 13:
            entry = {
              name: manifest.name,
              version: manifest.version,
              resolved: flags.resolved,
              registry: flags.registry || manifest._registry,
              optionalDependencies: manifest.optionalDependencies,
              dependencies: manifest.dependencies
            };
            pattern = flags.pattern || "".concat(entry.name, "@").concat(entry.version);
            reporter.log((0, _lockfile().stringify)((0, _defineProperty2()["default"])({}, pattern, (0, _lockfile().implodeEntry)(pattern, entry))));

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _run.apply(this, arguments);
}

function setFlags(commander) {
  commander.description('Generates a lock file entry.');
  commander.option('--use-manifest <location>', 'description');
  commander.option('--resolved <resolved>', 'description');
  commander.option('--registry <registry>', 'description');
}

var examples = ['generate-lock-entry', 'generate-lock-entry --use-manifest ./package.json', 'generate-lock-entry --resolved local-file.tgz#hash'];
exports.examples = examples;
//# sourceMappingURL=generate-lock-entry.js.map
