"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasWrapper = hasWrapper;
exports.setFlags = setFlags;
exports.run = run;

function _index() {
  var data = _interopRequireDefault(require("./index.js"));

  _index = function _index() {
    return data;
  };

  return data;
}

function constants() {
  var data = _interopRequireWildcard(require("../../constants.js"));

  constants = function constants() {
    return data;
  };

  return data;
}

function _misc() {
  var data = require("../../util/misc.js");

  _misc = function _misc() {
    return data;
  };

  return data;
}

function _aliases() {
  var data = _interopRequireDefault(require("../aliases"));

  _aliases = function _aliases() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var chalk = require('chalk');

function hasWrapper(flags, args) {
  return false;
}

function setFlags(commander) {
  commander.description('Displays help information.');
}

function run(config, reporter, commander, args) {
  if (args.length) {
    var commandName = args.shift();

    if (Object.prototype.hasOwnProperty.call(_index()["default"], commandName)) {
      var command = _index()["default"][commandName];

      if (command) {
        command.setFlags(commander);
        var examples = (command.examples || []).map(function (example) {
          return "    $ yarn ".concat(example);
        });

        if (examples.length) {
          commander.on('--help', function () {
            reporter.log(reporter.lang('helpExamples', reporter.rawText(examples.join('\n'))));
          });
        } // eslint-disable-next-line yarn-internal/warn-language


        commander.on('--help', function () {
          return reporter.log('  ' + command.getDocsInfo + '\n');
        });
        commander.help();
        return Promise.resolve();
      }
    }
  }

  commander.on('--help', function () {
    var commandsText = [];

    var _iterator = _createForOfIteratorHelper(Object.keys(_index()["default"]).sort(_misc().sortAlpha)),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var name = _step.value;

        if (_index()["default"][name].useless || Object.keys(_aliases()["default"]).map(function (key) {
          return _aliases()["default"][key];
        }).indexOf(name) > -1) {
          continue;
        }

        if (_aliases()["default"][name]) {
          commandsText.push("    - ".concat((0, _misc().hyphenate)(name), " / ").concat(_aliases()["default"][name]));
        } else {
          commandsText.push("    - ".concat((0, _misc().hyphenate)(name)));
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    reporter.log(reporter.lang('helpCommands', reporter.rawText(commandsText.join('\n'))));
    reporter.log(reporter.lang('helpCommandsMore', reporter.rawText(chalk.bold('yarn help COMMAND'))));
    reporter.log(reporter.lang('helpLearnMore', reporter.rawText(chalk.bold(constants().YARN_DOCS))));
  });
  commander.options.sort(_misc().sortOptionsByFlags);
  commander.help();
  return Promise.resolve();
}
//# sourceMappingURL=help.js.map
