"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setFlags = setFlags;
exports.hasWrapper = hasWrapper;
exports.run = run;
exports.getGitConfigInfo = getGitConfigInfo;
exports.shouldRunInCurrentCwd = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _typeof2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

  _typeof2 = function _typeof2() {
    return data;
  };

  return data;
}

function _toConsumableArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

  _toConsumableArray2 = function _toConsumableArray2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _util() {
  var data = require("../../util/normalize-manifest/util.js");

  _util = function _util() {
    return data;
  };

  return data;
}

function _index() {
  var data = require("../../registries/index.js");

  _index = function _index() {
    return data;
  };

  return data;
}

function _githubResolver() {
  var data = _interopRequireDefault(require("../../resolvers/exotics/github-resolver.js"));

  _githubResolver = function _githubResolver() {
    return data;
  };

  return data;
}

function child() {
  var data = _interopRequireWildcard(require("../../util/child.js"));

  child = function child() {
    return data;
  };

  return data;
}

function fs() {
  var data = _interopRequireWildcard(require("../../util/fs.js"));

  fs = function fs() {
    return data;
  };

  return data;
}

function validate() {
  var data = _interopRequireWildcard(require("../../util/normalize-manifest/validate.js"));

  validate = function validate() {
    return data;
  };

  return data;
}

function _constants() {
  var data = require("../../constants");

  _constants = function _constants() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var objectPath = require('object-path');

var path = require('path');

var yn = require('yn');

function setFlags(commander) {
  commander.description('Interactively creates or updates a package.json file.');
  commander.option('-y, --yes', 'use default options');
  commander.option('-p, --private', 'use default options and private true');
  commander.option('-i, --install <value>', 'install a specific Yarn release');
  commander.option('-2', 'generates the project using Yarn 2');
}

function hasWrapper(commander, args) {
  return true;
}

var shouldRunInCurrentCwd = true;
exports.shouldRunInCurrentCwd = shouldRunInCurrentCwd;

function run(_x, _x2, _x3, _x4) {
  return _run.apply(this, arguments);
}

function _run() {
  _run = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(config, reporter, flags, args) {
    var installVersion, lockfilePath, manifests, repository, author, keys, pkg, _i, _keys, entry, yes, privateFlag, manifestKey, question, def, _iterator, _step, registryName, object, val, answer, validAnswer, targetManifests, _iterator2, _step2, _registryName, info, _i2, _targetManifests, targetManifest;

    return _regenerator()["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            installVersion = flags["2"] ? "berry" : flags.install;

            if (!installVersion) {
              _context.next = 13;
              break;
            }

            lockfilePath = path.resolve(config.cwd, 'yarn.lock');
            _context.next = 5;
            return fs().exists(lockfilePath);

          case 5:
            if (_context.sent) {
              _context.next = 8;
              break;
            }

            _context.next = 8;
            return fs().writeFile(lockfilePath, '');

          case 8:
            _context.next = 10;
            return child().spawn(_constants().NODE_BIN_PATH, [process.argv[1], 'policies', 'set-version', installVersion, '--silent'], {
              stdio: 'inherit',
              cwd: config.cwd
            });

          case 10:
            _context.next = 12;
            return child().spawn(_constants().NODE_BIN_PATH, [process.argv[1], 'init'].concat((0, _toConsumableArray2()["default"])(flags.yes ? ['-y'] : []), (0, _toConsumableArray2()["default"])(flags["private"] ? ['-p'] : [])), {
              stdio: 'inherit',
              cwd: config.cwd
            });

          case 12:
            return _context.abrupt("return");

          case 13:
            _context.next = 15;
            return config.getRootManifests();

          case 15:
            manifests = _context.sent;
            repository = {};
            author = {
              name: config.getOption('init-author-name'),
              email: config.getOption('init-author-email'),
              url: config.getOption('init-author-url')
            };
            _context.next = 20;
            return fs().exists(path.join(config.cwd, '.git'));

          case 20:
            if (!_context.sent) {
              _context.next = 38;
              break;
            }

            _context.prev = 21;
            _context.next = 24;
            return child().spawn('git', ['config', 'remote.origin.url'], {
              cwd: config.cwd
            });

          case 24:
            _context.t0 = _context.sent;
            repository = {
              type: 'git',
              url: _context.t0
            };
            _context.next = 30;
            break;

          case 28:
            _context.prev = 28;
            _context.t1 = _context["catch"](21);

          case 30:
            if (!(author.name === undefined)) {
              _context.next = 34;
              break;
            }

            _context.next = 33;
            return getGitConfigInfo('user.name');

          case 33:
            author.name = _context.sent;

          case 34:
            if (!(author.email === undefined)) {
              _context.next = 38;
              break;
            }

            _context.next = 37;
            return getGitConfigInfo('user.email');

          case 37:
            author.email = _context.sent;

          case 38:
            keys = [{
              key: 'name',
              question: 'name',
              "default": path.basename(config.cwd),
              validation: validate().isValidPackageName,
              validationError: 'invalidPackageName'
            }, {
              key: 'version',
              question: 'version',
              "default": String(config.getOption('init-version'))
            }, {
              key: 'description',
              question: 'description',
              "default": ''
            }, {
              key: 'main',
              question: 'entry point',
              "default": 'index.js'
            }, {
              key: 'repository',
              question: 'repository url',
              "default": (0, _util().extractRepositoryUrl)(repository)
            }, {
              key: 'author',
              question: 'author',
              "default": (0, _util().stringifyPerson)(author)
            }, {
              key: 'license',
              question: 'license',
              "default": String(config.getOption('init-license'))
            }, {
              key: 'private',
              question: 'private',
              "default": config.getOption('init-private') || '',
              inputFormatter: yn
            }]; // get answers

            pkg = {};
            _i = 0, _keys = keys;

          case 41:
            if (!(_i < _keys.length)) {
              _context.next = 98;
              break;
            }

            entry = _keys[_i];
            yes = flags.yes, privateFlag = flags["private"];
            manifestKey = entry.key;
            question = entry.question, def = entry["default"];
            _iterator = _createForOfIteratorHelper(_index().registryNames);
            _context.prev = 47;

            _iterator.s();

          case 49:
            if ((_step = _iterator.n()).done) {
              _context.next = 59;
              break;
            }

            registryName = _step.value;
            object = manifests[registryName].object;
            val = objectPath.get(object, manifestKey);

            if (val) {
              _context.next = 55;
              break;
            }

            return _context.abrupt("break", 59);

          case 55:
            if ((0, _typeof2()["default"])(val) === 'object') {
              if (manifestKey === 'author') {
                val = (0, _util().stringifyPerson)(val);
              } else if (manifestKey === 'repository') {
                val = (0, _util().extractRepositoryUrl)(val);
              }
            }

            def = val;

          case 57:
            _context.next = 49;
            break;

          case 59:
            _context.next = 64;
            break;

          case 61:
            _context.prev = 61;
            _context.t2 = _context["catch"](47);

            _iterator.e(_context.t2);

          case 64:
            _context.prev = 64;

            _iterator.f();

            return _context.finish(64);

          case 67:
            if (manifestKey === 'private' && privateFlag) {
              def = true;
            }

            if (def) {
              question += " (".concat(String(def), ")");
            }

            answer = void 0;
            validAnswer = false;

            if (!yes) {
              _context.next = 75;
              break;
            }

            answer = def;
            _context.next = 94;
            break;

          case 75:
            if (!entry.validation) {
              _context.next = 88;
              break;
            }

          case 76:
            if (validAnswer) {
              _context.next = 86;
              break;
            }

            _context.next = 79;
            return reporter.question(question);

          case 79:
            _context.t3 = _context.sent;

            if (_context.t3) {
              _context.next = 82;
              break;
            }

            _context.t3 = def;

          case 82:
            answer = _context.t3;

            // validate answer
            if (entry.validation(String(answer))) {
              validAnswer = true;
            } else {
              reporter.error(reporter.lang('invalidPackageName'));
            }

            _context.next = 76;
            break;

          case 86:
            _context.next = 94;
            break;

          case 88:
            _context.next = 90;
            return reporter.question(question);

          case 90:
            _context.t4 = _context.sent;

            if (_context.t4) {
              _context.next = 93;
              break;
            }

            _context.t4 = def;

          case 93:
            answer = _context.t4;

          case 94:
            if (answer) {
              if (entry.inputFormatter) {
                answer = entry.inputFormatter(answer);
              }

              objectPath.set(pkg, manifestKey, answer);
            }

          case 95:
            _i++;
            _context.next = 41;
            break;

          case 98:
            if (pkg.repository && _githubResolver()["default"].isVersion(pkg.repository)) {
              pkg.repository = "https://github.com/".concat(pkg.repository);
            } // save answers


            targetManifests = [];
            _iterator2 = _createForOfIteratorHelper(_index().registryNames);

            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                _registryName = _step2.value;
                info = manifests[_registryName];

                if (info.exists) {
                  targetManifests.push(info);
                }
              }
            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }

            if (!targetManifests.length) {
              targetManifests.push(manifests.npm);
            }

            for (_i2 = 0, _targetManifests = targetManifests; _i2 < _targetManifests.length; _i2++) {
              targetManifest = _targetManifests[_i2];
              Object.assign(targetManifest.object, pkg);
              reporter.success("Saved ".concat(path.basename(targetManifest.loc)));
            }

            _context.next = 106;
            return config.saveRootManifests(manifests);

          case 106:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[21, 28], [47, 61, 64, 67]]);
  }));
  return _run.apply(this, arguments);
}

function getGitConfigInfo(_x5) {
  return _getGitConfigInfo.apply(this, arguments);
}

function _getGitConfigInfo() {
  _getGitConfigInfo = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(credential) {
    var spawn,
        _args2 = arguments;
    return _regenerator()["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            spawn = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : child().spawn;
            _context2.prev = 1;
            _context2.next = 4;
            return spawn('git', ['config', credential]);

          case 4:
            return _context2.abrupt("return", _context2.sent);

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2["catch"](1);
            return _context2.abrupt("return", '');

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[1, 7]]);
  }));
  return _getGitConfigInfo.apply(this, arguments);
}
//# sourceMappingURL=init.js.map
