"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mutate = mutate;
exports.setFlags = setFlags;
exports.examples = exports.hasWrapper = exports.run = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _errors() {
  var data = require("../../errors.js");

  _errors = function _errors() {
    return data;
  };

  return data;
}

function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));

  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };

  return data;
}

function _validate() {
  var data = require("../../util/normalize-manifest/validate.js");

  _validate = function _validate() {
    return data;
  };

  return data;
}

function _tag() {
  var data = require("./tag.js");

  _tag = function _tag() {
    return data;
  };

  return data;
}

function _login() {
  var data = require("./login.js");

  _login = function _login() {
    return data;
  };

  return data;
}

function _npmRegistry() {
  var data = _interopRequireDefault(require("../../registries/npm-registry.js"));

  _npmRegistry = function _npmRegistry() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function mutate(_x, _x2, _x3, _x4, _x5) {
  return _mutate.apply(this, arguments);
}

function _mutate() {
  _mutate = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(args, config, reporter, buildMessages, mutator) {
    var username, name, msgs, revoke, user, error, _pkg, res;

    return _regenerator()["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(args.length !== 2 && args.length !== 1)) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", false);

          case 2:
            username = args.shift();
            _context.next = 5;
            return (0, _tag().getName)(args, config);

          case 5:
            name = _context.sent;

            if ((0, _validate().isValidPackageName)(name)) {
              _context.next = 8;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('invalidPackageName'));

          case 8:
            msgs = buildMessages(username, name);
            reporter.step(1, 3, reporter.lang('loggingIn'));
            _context.next = 12;
            return (0, _login().getToken)(config, reporter, name);

          case 12:
            revoke = _context.sent;
            reporter.step(2, 3, msgs.info);
            _context.next = 16;
            return config.registries.npm.request("-/user/org.couchdb.user:".concat(username));

          case 16:
            user = _context.sent;
            error = false;

            if (!user) {
              _context.next = 30;
              break;
            }

            _context.next = 21;
            return config.registries.npm.request(_npmRegistry()["default"].escapeName(name));

          case 21:
            _pkg = _context.sent;

            if (_pkg) {
              _pkg.maintainers = _pkg.maintainers || [];
              error = mutator({
                name: user.name,
                email: user.email
              }, _pkg);
            } else {
              error = true;
              reporter.error(reporter.lang('unknownPackage', name));
            } // update package


            if (!(_pkg && !error)) {
              _context.next = 28;
              break;
            }

            _context.next = 26;
            return config.registries.npm.request("".concat(_npmRegistry()["default"].escapeName(name), "/-rev/").concat(_pkg._rev), {
              method: 'PUT',
              body: {
                _id: _pkg._id,
                _rev: _pkg._rev,
                maintainers: _pkg.maintainers
              }
            });

          case 26:
            res = _context.sent;

            if (res != null && res.success) {
              reporter.success(msgs.success);
            } else {
              error = true;
              reporter.error(msgs.error);
            }

          case 28:
            _context.next = 32;
            break;

          case 30:
            error = true;
            reporter.error(reporter.lang('unknownUser', username));

          case 32:
            reporter.step(3, 3, reporter.lang('revokingToken'));
            _context.next = 35;
            return revoke();

          case 35:
            if (!error) {
              _context.next = 39;
              break;
            }

            throw new Error();

          case 39:
            return _context.abrupt("return", true);

          case 40:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _mutate.apply(this, arguments);
}

function _list2(_x6, _x7, _x8, _x9) {
  return _list.apply(this, arguments);
}

function _list() {
  _list = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(config, reporter, flags, args) {
    var name, pkg, owners, _iterator2, _step2, owner;

    return _regenerator()["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(args.length > 1)) {
              _context2.next = 2;
              break;
            }

            return _context2.abrupt("return", false);

          case 2:
            _context2.next = 4;
            return (0, _tag().getName)(args, config);

          case 4:
            name = _context2.sent;
            reporter.step(1, 1, reporter.lang('ownerGetting', name));
            _context2.next = 8;
            return config.registries.npm.request(name, {
              unfiltered: true
            });

          case 8:
            pkg = _context2.sent;

            if (pkg) {
              owners = pkg.maintainers;

              if (!owners || !owners.length) {
                reporter.warn(reporter.lang('ownerNone'));
              } else {
                _iterator2 = _createForOfIteratorHelper(owners);

                try {
                  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                    owner = _step2.value;
                    reporter.info("".concat(owner.name, " <").concat(owner.email, ">"));
                  }
                } catch (err) {
                  _iterator2.e(err);
                } finally {
                  _iterator2.f();
                }
              }
            } else {
              reporter.error(reporter.lang('ownerGettingFailed'));
            }

            if (!pkg) {
              _context2.next = 14;
              break;
            }

            return _context2.abrupt("return", true);

          case 14:
            throw new Error();

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _list.apply(this, arguments);
}

function _remove(config, reporter, flags, args) {
  return mutate(args, config, reporter, function (username, name) {
    return {
      info: reporter.lang('ownerRemoving', username, name),
      success: reporter.lang('ownerRemoved'),
      error: reporter.lang('ownerRemoveError')
    };
  }, function (user, pkg) {
    var found = false;
    pkg.maintainers = pkg.maintainers.filter(function (o) {
      var match = o.name === user.name;
      found = found || match;
      return !match;
    });

    if (!found) {
      reporter.error(reporter.lang('userNotAnOwner', user.name));
    }

    return found;
  });
}

function setFlags(commander) {
  commander.description('Manages package owners.');
}

var _buildSubCommands = (0, _buildSubCommands2()["default"])('owner', {
  add: function add(config, reporter, flags, args) {
    return mutate(args, config, reporter, function (username, name) {
      return {
        info: reporter.lang('ownerAdding', username, name),
        success: reporter.lang('ownerAdded'),
        error: reporter.lang('ownerAddingFailed')
      };
    }, function (user, pkg) {
      var _iterator = _createForOfIteratorHelper(pkg.maintainers),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var owner = _step.value;

          if (owner.name === user) {
            reporter.error(reporter.lang('ownerAlready'));
            return true;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      pkg.maintainers.push(user);
      return false;
    });
  },
  rm: function rm(config, reporter, flags, args) {
    reporter.warn("`yarn owner rm` is deprecated. Please use `yarn owner remove`.");
    return _remove(config, reporter, flags, args);
  },
  remove: function remove(config, reporter, flags, args) {
    return _remove(config, reporter, flags, args);
  },
  ls: function ls(config, reporter, flags, args) {
    reporter.warn("`yarn owner ls` is deprecated. Please use `yarn owner list`.");
    return _list2(config, reporter, flags, args);
  },
  list: function list(config, reporter, flags, args) {
    return _list2(config, reporter, flags, args);
  }
}, ['add <user> [[<@scope>/]<pkg>]', 'remove <user> [[<@scope>/]<pkg>]', 'list [<@scope>/]<pkg>']),
    run = _buildSubCommands.run,
    hasWrapper = _buildSubCommands.hasWrapper,
    examples = _buildSubCommands.examples;

exports.examples = examples;
exports.hasWrapper = hasWrapper;
exports.run = run;
//# sourceMappingURL=owner.js.map
