"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasWrapper = hasWrapper;
exports.examples = exports.setFlags = exports.run = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));

  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };

  return data;
}

function _rc() {
  var data = require("../../rc.js");

  _rc = function _rc() {
    return data;
  };

  return data;
}

function fs() {
  var data = _interopRequireWildcard(require("../../util/fs.js"));

  fs = function fs() {
    return data;
  };

  return data;
}

function _lockfile() {
  var data = require("../../lockfile");

  _lockfile = function _lockfile() {
    return data;
  };

  return data;
}

var chalk = require('chalk');

var invariant = require('invariant');

var path = require('path');

var semver = require('semver');

function getBundleAsset(release) {
  return release.assets.find(function (asset) {
    return asset.name.match(/^yarn-[0-9]+\.[0-9]+\.[0-9]+\.js$/);
  });
}

function fetchReleases(_x) {
  return _fetchReleases.apply(this, arguments);
}

function _fetchReleases() {
  _fetchReleases = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(config) {
    var _ref,
        _ref$includePrereleas,
        includePrereleases,
        token,
        tokenUrlParameter,
        request,
        releases,
        _args2 = arguments;

    return _regenerator()["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _ref = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {}, _ref$includePrereleas = _ref.includePrereleases, includePrereleases = _ref$includePrereleas === void 0 ? false : _ref$includePrereleas;
            token = process.env.GITHUB_TOKEN;
            tokenUrlParameter = token ? "?access_token=".concat(token) : '';
            _context2.next = 5;
            return config.requestManager.request({
              url: "https://api.github.com/repos/yarnpkg/yarn/releases".concat(tokenUrlParameter),
              json: true
            });

          case 5:
            request = _context2.sent;
            releases = request.filter(function (release) {
              if (release.draft) {
                return false;
              }

              if (release.prerelease && !includePrereleases) {
                return false;
              } // $FlowFixMe


              release.version = semver.coerce(release.tag_name);

              if (!release.version) {
                return false;
              }

              if (!getBundleAsset(release)) {
                return false;
              }

              return true;
            });
            releases.sort(function (a, b) {
              // $FlowFixMe
              return -semver.compare(a.version, b.version);
            });
            return _context2.abrupt("return", releases);

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _fetchReleases.apply(this, arguments);
}

function fetchBundle(config, url) {
  return config.requestManager.request({
    url: url,
    buffer: true
  });
}

function hasWrapper(flags, args) {
  return false;
}

var _buildSubCommands = (0, _buildSubCommands2()["default"])('policies', {
  setVersion: function setVersion(config, reporter, flags, args) {
    return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee() {
      var range, allowRc, bundleUrl, bundleVersion, isV2, releases, release, asset, bundle, yarnPath, targetPath, rcPath, _rcPath, rc;

      return _regenerator()["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              range = args[0] || 'latest';
              allowRc = flags.rc;
              reporter.log("Resolving ".concat(chalk.yellow(range), " to a url..."));

              if (range === 'rc') {
                range = 'latest';
                allowRc = true;
              }

              if (range === 'latest') {
                range = '*';
              }

              isV2 = false;

              if (!(range === 'nightly' || range === 'nightlies')) {
                _context.next = 11;
                break;
              }

              bundleUrl = 'https://nightly.yarnpkg.com/latest.js';
              bundleVersion = 'nightly';
              _context.next = 35;
              break;

            case 11:
              if (!(range === 'berry' || range === 'v2' || range === '2')) {
                _context.next = 17;
                break;
              }

              bundleUrl = 'https://github.com/yarnpkg/berry/raw/master/packages/berry-cli/bin/berry.js';
              bundleVersion = 'berry';
              isV2 = true;
              _context.next = 35;
              break;

            case 17:
              releases = [];
              _context.prev = 18;
              _context.next = 21;
              return fetchReleases(config, {
                includePrereleases: allowRc
              });

            case 21:
              releases = _context.sent;
              _context.next = 28;
              break;

            case 24:
              _context.prev = 24;
              _context.t0 = _context["catch"](18);
              reporter.error(_context.t0.message);
              return _context.abrupt("return");

            case 28:
              release = releases.find(function (release) {
                // $FlowFixMe
                return semver.satisfies(release.version, range);
              });

              if (release) {
                _context.next = 31;
                break;
              }

              throw new Error("Release not found: ".concat(range));

            case 31:
              asset = getBundleAsset(release);
              invariant(asset, 'The bundle asset should exist');
              bundleUrl = asset.browser_download_url;
              bundleVersion = release.version.version;

            case 35:
              reporter.log("Downloading ".concat(chalk.green(bundleUrl), "..."));
              _context.next = 38;
              return fetchBundle(config, bundleUrl);

            case 38:
              bundle = _context.sent;
              yarnPath = path.resolve(config.lockfileFolder, ".yarn/releases/yarn-".concat(bundleVersion, ".cjs"));
              reporter.log("Saving it into ".concat(chalk.magenta(yarnPath), "..."));
              _context.next = 43;
              return fs().mkdirp(path.dirname(yarnPath));

            case 43:
              _context.next = 45;
              return fs().writeFile(yarnPath, bundle);

            case 45:
              _context.next = 47;
              return fs().chmod(yarnPath, 493);

            case 47:
              targetPath = path.relative(config.lockfileFolder, yarnPath).replace(/\\/g, '/');

              if (!isV2) {
                _context.next = 55;
                break;
              }

              rcPath = "".concat(config.lockfileFolder, "/.yarnrc.yml");
              reporter.log("Updating ".concat(chalk.magenta(rcPath), "..."));
              _context.next = 53;
              return fs().writeFilePreservingEol(rcPath, "yarnPath: ".concat(JSON.stringify(targetPath), "\n"));

            case 53:
              _context.next = 61;
              break;

            case 55:
              _rcPath = "".concat(config.lockfileFolder, "/.yarnrc");
              reporter.log("Updating ".concat(chalk.magenta(_rcPath), "..."));
              rc = (0, _rc().getRcConfigForFolder)(config.lockfileFolder);
              rc['yarn-path'] = targetPath;
              _context.next = 61;
              return fs().writeFilePreservingEol(_rcPath, "".concat((0, _lockfile().stringify)(rc), "\n"));

            case 61:
              reporter.log("Done!");

            case 62:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[18, 24]]);
    }))();
  }
}),
    run = _buildSubCommands.run,
    setFlags = _buildSubCommands.setFlags,
    examples = _buildSubCommands.examples;

exports.examples = examples;
exports.setFlags = setFlags;
exports.run = run;
//# sourceMappingURL=policies.js.map
