"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setFlags = setFlags;
exports.examples = exports.hasWrapper = exports.run = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _toArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

  _toArray2 = function _toArray2() {
    return data;
  };

  return data;
}

function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));

  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };

  return data;
}

function _login() {
  var data = require("./login.js");

  _login = function _login() {
    return data;
  };

  return data;
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2()["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function explodeScopeTeam(arg, requireTeam, reporter) {
  var _arg$split = arg.split(':'),
      _arg$split2 = (0, _toArray2()["default"])(_arg$split),
      scope = _arg$split2[0],
      team = _arg$split2[1],
      parts = _arg$split2.slice(2);

  if (parts.length) {
    return false;
  }

  if (requireTeam && !team) {
    return false;
  }

  return {
    scope: scope || '',
    team: team || '',
    user: ''
  };
}

function warnDeprecation(reporter, deprecationWarning) {
  var command = 'yarn team';
  reporter.warn(reporter.lang('deprecatedCommand', "".concat(command, " ").concat(deprecationWarning.deprecatedCommand), "".concat(command, " ").concat(deprecationWarning.currentCommand)));
}

function wrapRequired(callback, requireTeam, deprecationInfo) {
  return /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(config, reporter, flags, args) {
      var parts, revoke, res;
      return _regenerator()["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (deprecationInfo) {
                warnDeprecation(reporter, deprecationInfo);
              }

              if (args.length) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return", false);

            case 3:
              parts = explodeScopeTeam(args[0], requireTeam, reporter);

              if (parts) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return", false);

            case 6:
              reporter.step(1, 3, reporter.lang('loggingIn'));
              _context.next = 9;
              return (0, _login().getToken)(config, reporter);

            case 9:
              revoke = _context.sent;
              _context.next = 12;
              return callback(parts, config, reporter, flags, args);

            case 12:
              res = _context.sent;

              if (res) {
                _context.next = 15;
                break;
              }

              return _context.abrupt("return", res);

            case 15:
              reporter.step(3, 3, reporter.lang('revokingToken'));
              _context.next = 18;
              return revoke();

            case 18:
              return _context.abrupt("return", true);

            case 19:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }();
}

function wrapRequiredTeam(callback) {
  var requireTeam = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var subCommandDeprecated = arguments.length > 2 ? arguments[2] : undefined;
  return wrapRequired(function (parts, config, reporter, flags, args) {
    if (args.length === 1) {
      return callback(parts, config, reporter, flags, args);
    } else {
      return false;
    }
  }, requireTeam, subCommandDeprecated);
}

function wrapRequiredUser(callback, subCommandDeprecated) {
  return wrapRequired(function (parts, config, reporter, flags, args) {
    if (args.length === 2) {
      return callback(_objectSpread({
        user: args[1]
      }, parts), config, reporter, flags, args);
    } else {
      return false;
    }
  }, true, subCommandDeprecated);
}

function removeTeamUser(_x5, _x6, _x7) {
  return _removeTeamUser.apply(this, arguments);
}

function _removeTeamUser() {
  _removeTeamUser = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee5(parts, config, reporter) {
    return _regenerator()["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            reporter.step(2, 3, reporter.lang('teamRemovingUser'));
            _context5.t0 = reporter;
            _context5.next = 4;
            return config.registries.npm.request("team/".concat(parts.scope, "/").concat(parts.team, "/user"), {
              method: 'DELETE',
              body: {
                user: parts.user
              }
            });

          case 4:
            _context5.t1 = _context5.sent;

            _context5.t0.inspect.call(_context5.t0, _context5.t1);

            return _context5.abrupt("return", true);

          case 7:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _removeTeamUser.apply(this, arguments);
}

function list(_x8, _x9, _x10) {
  return _list.apply(this, arguments);
}

function _list() {
  _list = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee6(parts, config, reporter) {
    var uriParams;
    return _regenerator()["default"].wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            reporter.step(2, 3, reporter.lang('teamListing'));
            uriParams = '?format=cli';

            if (!parts.team) {
              _context6.next = 10;
              break;
            }

            _context6.t0 = reporter;
            _context6.next = 6;
            return config.registries.npm.request("team/".concat(parts.scope, "/").concat(parts.team, "/user").concat(uriParams));

          case 6:
            _context6.t1 = _context6.sent;

            _context6.t0.inspect.call(_context6.t0, _context6.t1);

            _context6.next = 15;
            break;

          case 10:
            _context6.t2 = reporter;
            _context6.next = 13;
            return config.registries.npm.request("org/".concat(parts.scope, "/team").concat(uriParams));

          case 13:
            _context6.t3 = _context6.sent;

            _context6.t2.inspect.call(_context6.t2, _context6.t3);

          case 15:
            return _context6.abrupt("return", true);

          case 16:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _list.apply(this, arguments);
}

function setFlags(commander) {
  commander.description('Maintain team memberships');
}

var _buildSubCommands = (0, _buildSubCommands2()["default"])('team', {
  create: wrapRequiredTeam( /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(parts, config, reporter, flags, args) {
      return _regenerator()["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              reporter.step(2, 3, reporter.lang('teamCreating'));
              _context2.t0 = reporter;
              _context2.next = 4;
              return config.registries.npm.request("team/".concat(parts.scope), {
                method: 'PUT',
                body: {
                  team: parts.team
                }
              });

            case 4:
              _context2.t1 = _context2.sent;

              _context2.t0.inspect.call(_context2.t0, _context2.t1);

              return _context2.abrupt("return", true);

            case 7:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x11, _x12, _x13, _x14, _x15) {
      return _ref2.apply(this, arguments);
    };
  }()),
  destroy: wrapRequiredTeam( /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee3(parts, config, reporter, flags, args) {
      return _regenerator()["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              reporter.step(2, 3, reporter.lang('teamRemoving'));
              _context3.t0 = reporter;
              _context3.next = 4;
              return config.registries.npm.request("team/".concat(parts.scope, "/").concat(parts.team), {
                method: 'DELETE'
              });

            case 4:
              _context3.t1 = _context3.sent;

              _context3.t0.inspect.call(_context3.t0, _context3.t1);

              return _context3.abrupt("return", true);

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x16, _x17, _x18, _x19, _x20) {
      return _ref3.apply(this, arguments);
    };
  }()),
  add: wrapRequiredUser( /*#__PURE__*/function () {
    var _ref4 = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee4(parts, config, reporter, flags, args) {
      return _regenerator()["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              reporter.step(2, 3, reporter.lang('teamAddingUser'));
              _context4.t0 = reporter;
              _context4.next = 4;
              return config.registries.npm.request("team/".concat(parts.scope, "/").concat(parts.team, "/user"), {
                method: 'PUT',
                body: {
                  user: parts.user
                }
              });

            case 4:
              _context4.t1 = _context4.sent;

              _context4.t0.inspect.call(_context4.t0, _context4.t1);

              return _context4.abrupt("return", true);

            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x21, _x22, _x23, _x24, _x25) {
      return _ref4.apply(this, arguments);
    };
  }()),
  rm: wrapRequiredUser(function (parts, config, reporter, flags, args) {
    removeTeamUser(parts, config, reporter);
  }, {
    deprecatedCommand: 'rm',
    currentCommand: 'remove'
  }),
  remove: wrapRequiredUser(function (parts, config, reporter, flags, args) {
    removeTeamUser(parts, config, reporter);
  }),
  ls: wrapRequiredTeam(function (parts, config, reporter, flags, args) {
    list(parts, config, reporter);
  }, false, {
    deprecatedCommand: 'ls',
    currentCommand: 'list'
  }),
  list: wrapRequiredTeam(function (parts, config, reporter, flags, args) {
    list(parts, config, reporter);
  }, false)
}, ['create <scope:team>', 'destroy <scope:team>', 'add <scope:team> <user>', 'remove <scope:team> <user>', 'list <scope>|<scope:team>']),
    run = _buildSubCommands.run,
    hasWrapper = _buildSubCommands.hasWrapper,
    examples = _buildSubCommands.examples;

exports.examples = examples;
exports.hasWrapper = hasWrapper;
exports.run = run;
//# sourceMappingURL=team.js.map
