"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasWrapper = hasWrapper;
exports.info = _info2;
exports.runScript = runScript;
exports.examples = exports.setFlags = exports.run = void 0;

function _toConsumableArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

  _toConsumableArray2 = function _toConsumableArray2() {
    return data;
  };

  return data;
}

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _errors() {
  var data = require("../../errors.js");

  _errors = function _errors() {
    return data;
  };

  return data;
}

function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));

  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };

  return data;
}

function _constants() {
  var data = require("../../constants.js");

  _constants = function _constants() {
    return data;
  };

  return data;
}

function child() {
  var data = _interopRequireWildcard(require("../../util/child.js"));

  child = function child() {
    return data;
  };

  return data;
}

function _constants2() {
  var data = require("../../constants");

  _constants2 = function _constants2() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var invariant = require('invariant');

var path = require('path');

var os = require('os');

var semver = require('semver');

function hasWrapper(commander, args) {
  return true;
}

function _info2(_x, _x2, _x3, _x4) {
  return _info.apply(this, arguments);
}

function _info() {
  _info = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee3(config, reporter, flags, args) {
    var workspaceRootFolder, manifest, workspaces, publicData, _i, _Object$keys, workspaceName, _workspaces$workspace, loc, _manifest, workspaceDependencies, mismatchedWorkspaceDependencies, _iterator, _step, dependencyType, _i2, _Object$keys2, dependencyName, requestedRange;

    return _regenerator()["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            workspaceRootFolder = config.workspaceRootFolder;

            if (workspaceRootFolder) {
              _context3.next = 3;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('workspaceRootNotFound', config.cwd));

          case 3:
            _context3.next = 5;
            return config.findManifest(workspaceRootFolder, false);

          case 5:
            manifest = _context3.sent;
            invariant(manifest && manifest.workspaces, 'We must find a manifest with a "workspaces" property');
            _context3.next = 9;
            return config.resolveWorkspaces(workspaceRootFolder, manifest);

          case 9:
            workspaces = _context3.sent;
            publicData = {};

            for (_i = 0, _Object$keys = Object.keys(workspaces); _i < _Object$keys.length; _i++) {
              workspaceName = _Object$keys[_i];
              _workspaces$workspace = workspaces[workspaceName], loc = _workspaces$workspace.loc, _manifest = _workspaces$workspace.manifest;
              workspaceDependencies = new Set();
              mismatchedWorkspaceDependencies = new Set();
              _iterator = _createForOfIteratorHelper(_constants().DEPENDENCY_TYPES);

              try {
                for (_iterator.s(); !(_step = _iterator.n()).done;) {
                  dependencyType = _step.value;

                  if (dependencyType !== 'peerDependencies') {
                    for (_i2 = 0, _Object$keys2 = Object.keys(_manifest[dependencyType] || {}); _i2 < _Object$keys2.length; _i2++) {
                      dependencyName = _Object$keys2[_i2];

                      if (Object.prototype.hasOwnProperty.call(workspaces, dependencyName)) {
                        invariant(_manifest && _manifest[dependencyType], 'The request should exist');
                        requestedRange = _manifest[dependencyType][dependencyName];

                        if (semver.satisfies(workspaces[dependencyName].manifest.version, requestedRange)) {
                          workspaceDependencies.add(dependencyName);
                        } else {
                          mismatchedWorkspaceDependencies.add(dependencyName);
                        }
                      }
                    }
                  }
                }
              } catch (err) {
                _iterator.e(err);
              } finally {
                _iterator.f();
              }

              publicData[workspaceName] = {
                location: path.relative(config.lockfileFolder, loc).replace(/\\/g, '/'),
                workspaceDependencies: Array.from(workspaceDependencies),
                mismatchedWorkspaceDependencies: Array.from(mismatchedWorkspaceDependencies)
              };
            }

            reporter.log(JSON.stringify(publicData, null, 2), {
              force: true
            });

          case 13:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _info.apply(this, arguments);
}

function runScript(_x5, _x6, _x7, _x8) {
  return _runScript.apply(this, arguments);
}

function _runScript() {
  _runScript = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee4(config, reporter, flags, args) {
    var workspaceRootFolder, manifest, workspaces, _i3, _Object$keys3, workspaceName, loc;

    return _regenerator()["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            workspaceRootFolder = config.workspaceRootFolder;

            if (workspaceRootFolder) {
              _context4.next = 3;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('workspaceRootNotFound', config.cwd));

          case 3:
            _context4.next = 5;
            return config.findManifest(workspaceRootFolder, false);

          case 5:
            manifest = _context4.sent;
            invariant(manifest && manifest.workspaces, 'We must find a manifest with a "workspaces" property');
            _context4.next = 9;
            return config.resolveWorkspaces(workspaceRootFolder, manifest);

          case 9:
            workspaces = _context4.sent;
            _context4.prev = 10;
            _i3 = 0, _Object$keys3 = Object.keys(workspaces);

          case 12:
            if (!(_i3 < _Object$keys3.length)) {
              _context4.next = 21;
              break;
            }

            workspaceName = _Object$keys3[_i3];
            loc = workspaces[workspaceName].loc;
            reporter.log("".concat(os.EOL, "> ").concat(workspaceName));
            _context4.next = 18;
            return child().spawn(_constants2().NODE_BIN_PATH, [_constants2().YARN_BIN_PATH, 'run'].concat((0, _toConsumableArray2()["default"])(args)), {
              stdio: 'inherit',
              cwd: loc
            });

          case 18:
            _i3++;
            _context4.next = 12;
            break;

          case 21:
            _context4.next = 26;
            break;

          case 23:
            _context4.prev = 23;
            _context4.t0 = _context4["catch"](10);
            throw _context4.t0;

          case 26:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, null, [[10, 23]]);
  }));
  return _runScript.apply(this, arguments);
}

var _buildSubCommands = (0, _buildSubCommands2()["default"])('workspaces', {
  info: function info(config, reporter, flags, args) {
    return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee() {
      return _regenerator()["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _info2(config, reporter, flags, args);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  },
  run: function run(config, reporter, flags, args) {
    return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2() {
      return _regenerator()["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return runScript(config, reporter, flags, args);

            case 2:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }))();
  }
}),
    run = _buildSubCommands.run,
    setFlags = _buildSubCommands.setFlags,
    examples = _buildSubCommands.examples;

exports.examples = examples;
exports.setFlags = setFlags;
exports.run = run;
//# sourceMappingURL=workspaces.js.map
