"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.explodeGistFragment = explodeGistFragment;
exports["default"] = void 0;

function _classCallCheck2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

  _classCallCheck2 = function _classCallCheck2() {
    return data;
  };

  return data;
}

function _createClass2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

  _createClass2 = function _createClass2() {
    return data;
  };

  return data;
}

function _assertThisInitialized2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

  _assertThisInitialized2 = function _assertThisInitialized2() {
    return data;
  };

  return data;
}

function _inherits2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

  _inherits2 = function _inherits2() {
    return data;
  };

  return data;
}

function _possibleConstructorReturn2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

  _possibleConstructorReturn2 = function _possibleConstructorReturn2() {
    return data;
  };

  return data;
}

function _getPrototypeOf2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

  _getPrototypeOf2 = function _getPrototypeOf2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _errors() {
  var data = require("../../errors.js");

  _errors = function _errors() {
    return data;
  };

  return data;
}

function _gitResolver() {
  var data = _interopRequireDefault(require("./git-resolver.js"));

  _gitResolver = function _gitResolver() {
    return data;
  };

  return data;
}

function _exoticResolver() {
  var data = _interopRequireDefault(require("./exotic-resolver.js"));

  _exoticResolver = function _exoticResolver() {
    return data;
  };

  return data;
}

function util() {
  var data = _interopRequireWildcard(require("../../util/misc.js"));

  util = function util() {
    return data;
  };

  return data;
}

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2()["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2()["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2()["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function explodeGistFragment(fragment, reporter) {
  fragment = util().removePrefix(fragment, 'gist:');
  var parts = fragment.split('#');

  if (parts.length <= 2) {
    return {
      id: parts[0],
      hash: parts[1] || ''
    };
  } else {
    throw new (_errors().MessageError)(reporter.lang('invalidGistFragment', fragment));
  }
}

var GistResolver = /*#__PURE__*/function (_ExoticResolver) {
  (0, _inherits2()["default"])(GistResolver, _ExoticResolver);

  var _super = _createSuper(GistResolver);

  function GistResolver(request, fragment) {
    var _this;

    (0, _classCallCheck2()["default"])(this, GistResolver);
    _this = _super.call(this, request, fragment);
    (0, _defineProperty2()["default"])((0, _assertThisInitialized2()["default"])(_this), "id", void 0);
    (0, _defineProperty2()["default"])((0, _assertThisInitialized2()["default"])(_this), "hash", void 0);

    var _explodeGistFragment = explodeGistFragment(fragment, _this.reporter),
        id = _explodeGistFragment.id,
        hash = _explodeGistFragment.hash;

    _this.id = id;
    _this.hash = hash;
    return _this;
  }

  (0, _createClass2()["default"])(GistResolver, [{
    key: "resolve",
    value: function resolve() {
      return this.fork(_gitResolver()["default"], false, "https://gist.github.com/".concat(this.id, ".git#").concat(this.hash));
    }
  }]);
  return GistResolver;
}(_exoticResolver()["default"]);

exports["default"] = GistResolver;
(0, _defineProperty2()["default"])(GistResolver, "protocol", 'gist');
//# sourceMappingURL=gist-resolver.js.map
