"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

function _constants() {
  var data = require("../../constants.js");

  _constants = function _constants() {
    return data;
  };

  return data;
}

function _fileResolver() {
  var data = require("../../resolvers/exotics/file-resolver.js");

  _fileResolver = function _fileResolver() {
    return data;
  };

  return data;
}

function _linkResolver() {
  var data = require("../../resolvers/exotics/link-resolver.js");

  _linkResolver = function _linkResolver() {
    return data;
  };

  return data;
}

function _invariant() {
  var data = _interopRequireDefault(require("invariant"));

  _invariant = function _invariant() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var path = require('path');

function _default(info, moduleLoc, lockfileFolder) {
  // It won't work if we don't yet know what's the folder we'll use as root. It's not a
  // big deal tho, because it only happens when trying to figure out the root, and we
  // don't need to know the dependencies / devDependencies at this time.
  if (!lockfileFolder) {
    return;
  }

  var _iterator = _createForOfIteratorHelper(_constants().DEPENDENCY_TYPES),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var dependencyType = _step.value;
      var dependencies = info[dependencyType];

      if (!dependencies) {
        continue;
      }

      for (var _i = 0, _Object$keys = Object.keys(dependencies); _i < _Object$keys.length; _i++) {
        var name = _Object$keys[_i];
        var value = dependencies[name];

        if (path.isAbsolute(value)) {
          value = _fileResolver().FILE_PROTOCOL_PREFIX + value;
        }

        var prefix = void 0;

        if (value.startsWith(_fileResolver().FILE_PROTOCOL_PREFIX)) {
          prefix = _fileResolver().FILE_PROTOCOL_PREFIX;
        } else if (value.startsWith(_linkResolver().LINK_PROTOCOL_PREFIX)) {
          prefix = _linkResolver().LINK_PROTOCOL_PREFIX;
        } else {
          continue;
        }

        (0, _invariant()["default"])(prefix, 'prefix is definitely defined here');
        var unprefixed = value.substr(prefix.length);
        var hasPathPrefix = /^\.(\/|$)/.test(unprefixed);
        var absoluteTarget = path.resolve(lockfileFolder, moduleLoc, unprefixed);
        var relativeTarget = path.relative(lockfileFolder, absoluteTarget) || '.';

        if (absoluteTarget === lockfileFolder) {
          relativeTarget = '.';
        } else if (hasPathPrefix) {
          // TODO: This logic should be removed during the next major bump
          // If the original value was using the "./" prefix, then we output a similar path.
          // We need to do this because otherwise it would cause problems with already existing
          // lockfile, which would see some of their entries being unrecognized.
          relativeTarget = relativeTarget.replace(/^(?!\.{0,2}\/)/, "./");
        }

        dependencies[name] = prefix + relativeTarget.replace(/\\/g, '/');
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}
//# sourceMappingURL=resolve-relative.js.map
