"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPosixPath = getPosixPath;
exports.resolveWithHome = resolveWithHome;

function _path() {
  var data = require("path");

  _path = function _path() {
    return data;
  };

  return data;
}

var userHome = require('./user-home-dir')["default"];

function getPosixPath(path) {
  return path.replace(/\\/g, '/');
}

function resolveWithHome(path) {
  var homePattern = process.platform === 'win32' ? /^~(\/|\\)/ : /^~\//;

  if (homePattern.test(path)) {
    return (0, _path().resolve)(userHome, path.substr(2));
  }

  return (0, _path().resolve)(path);
}
//# sourceMappingURL=path.js.map
